Index: Tst/Short/string.res.gz.uu
===================================================================
--- Tst/Short/string.res.gz.uu	(revision 199cd68d23f96331d3327f7a0b11a46accefa1db)
+++ Tst/Short/string.res.gz.uu	(revision 1035602ff5b8a29d54e29d4d0b863eab2f4ecab4)
@@ -1,82 +1,81 @@
 begin 640 string.res.gz
-M'XL(".]\@$T``W-T<FEN9RYR97,`[5UM;]LX$O[.7T$85\!N6%>B_!I?`FQW
-M]T.!S6&!WH<#LD'AQ&KCK6RKLM+:/MQ_OR$IBI1$R5+LQ+&CH*AEO@R',P]'
-M,R/2^O3OWS[^"V-L7^(_/G[`C7`9MKWI;6.$/D4U]!)#X>?I?!HV6R/$/O'E
-M)5Z&P73^M3UW?[:7X3B,FSN7.+[NM-5UMXW]8'&'K]9_0L>P.7&_X)_WX[`5
-MM^BU\7_C+_TV_(<;K(7&RY"7LL*XS+9%2Y]3Y115!]OAE5J=JNJ*?F(>F8YB
-M?+U2U0W3(Q+\5^/-\J^&1H#:J9$)AB8-184Z1BI^DDK70,77J?2-5+PDE:&!
-MBJ=1<3(RY%1&"2I.6I:,RDBGTC52H4G!.'T#&:I+QC'+ER8GU3$)F.JSZI@E
-M'";)F"0<ZE2`W__%7P8*W1U@TYLN0^SA"VP33$=Q5=>ZC''N`2E&%UW;-^>(
-MK31T3<4511HPC?4Z_I!-]`X1G@RE@`\C,90!`&+\-UFAW2+L@[9:**/@,L2H
-M8`5E*]+#(#D.RL@<O7_/US9._P$#F,N:X.5TXY[#^":>I/1MI:0NE4KR8HUV
-M'4T[L7K<F1^N>=N$5K3BA#(,FC"H0>N=)WV3P/.[<3GGRW@WJ5KZP%)8'4V8
-ML%88V#U\EI!GKT;[`='>UQ0T$`J:SI=N`,H@F.-;U@X+]*1I7@X!@SE%JMO2
-M96=M;J&?IV"Q$$AI/5<;IH3J(P;0/B'@E&4WTG7/4JCHP9W2N[:M&T!&-T9#
-MCVHMX$X9J8L!`]1"NG%=Y_&H88/RR^YC`*3U3F.)=,UHRI17P),V7!5H\8_N
-M+@C+'S@&&T'9NBUX$Y_='7%G6X^8A41.5T-8CV'0N>'&*?SAWC69MAQEG'I@
-MQKSK#FO0N)\J_ZPW>"S\^``(2/)O]].=T%A$+`5.WI3<3W,PFEM=&JI%O)1&
-MKE(!8?+>%<45>)*@%H)`((F*X-981YSW9T5ZT4PE9H<*^'V+`;_'<,VGTKA?
-M-("W>U<+,?KV_C#>$Y>R-RM=\`*J"MP]+X7*8^:MF/L%N7>WK1MSHQU63V7V
-M'[W(%`(X`/:_Z':=BF%M@K@1R'OG-:KFCL3D#[QJ*XM*+E;-;^H[;'$/V.*.
-MUJ]:TX]VFQ[-ZD!\`]EYT]OY>.9B?(ZC$I9ZXT7GDJNH(ES[+J=P#A*=?WWP
-MQL%AK,-3<%]L9_QQ`#1#-\`R%SG"B'6464<L4XTXDU_$J:0BSF82<3I]B'-S
-MAMB8*#2T]W/:^SGMO9SV7D[[44[[44Y[FC<!FC<#FL<2S>,IS.G`DW0(C0(W
-M?`CF+#6-RMTZ:KV?O-Z?WAMX"G.U-[^B44/\U"#^!!':RT%Z@=M9(_G4D/P4
-MH41M\$X.)@=/ZQS0/,H84DN@]ED"=3K_!O^Q%.G[<.:K)&F?)T\'(LFD2O>8
-M.JTL##[#<_S+IU\_?HR*9HN)JV03R85-)"I9^.X<2N:+Z'O@CB?\>\@OUU'Q
-MSV`:NGKQ@</5P\RT.+1E8Y4+AHPMG]-]/HSX]N9JLS79%,OQ</F\%R;-`G>.
-MP^T)'("$&H[MQG$8I<F[A/:P8F"U,3,K.(AO(@/MV40@;R)`&>.[>_"Y[L#E
-M`KE,[V!PAUJ6(^KF#[-;\,467_"/<;!D=:*<_]UZB[MO3')0O@@F+A]QXFLM
-MU-\YG_N27:[P&F\,9*A.YM?$+>`E\YDPX$W.4XLT5V1--O`Y\9OP]=>T*6$+
-MJVQ;O_&R!6`PP8W<N34,-O6()D>+%6>RAD6RJ&K7WC*N7K2\I+71'JX,G#:>
-M3MRQAY5+.]">JDRE-6+_P30OK,3:MY(KS#*LI'29S\L,N.1L-"W3C5T-;E)Y
-MMC1!KJH>A3B:GSZT".CAJSMW@W&X")I+G0\I*@@>E"PA>HBT.V>[5:G343N!
-M!GTEU+D4*F^2$*@H2?J=J4:QEVDH]^-R@X`%;TU>;Y*RL2-=YM9D:585M>@=
-MD9>"&N@B';8Q>"8@?OP#1'J].K,)7M_$4AUJ>X!_2*FNWH+2P*\Y6_,+VCH3
-MWY.!"R.UODF*ND1/*?V23;F3'PUE4(F86S./F$E+N0.;%%>Z<2EFJJI7$,QG
-M0BK1UC0^I&WL+[PU]D'?*WJV=L[F2MW:IF)?JAM:0+OL4M++$UHV=Y"*S:_U
-M4[4&?3+.FUH;DP(+2-`T`R8U9<>HJA=&(3&,%*^V#7G8C9^Z*S]UV&,ID"'?
-M8*8*>5ZDSPHU3<$J9MD:-MX%_J'*V7[^ZRXK]&6A;17MY*\8%W3%I3Z[LK%"
-M/Z(I.JG(X<7>ST$3G,?/XIZTWQ1-+<BB#)`FEBC'(ZYS_4EB;4L5[8/D#CFE
-M6M\[I:PR5CF3Q$JX2J0@\B#2==U_JJM6<KE,FKX6X[1:]#5_/2)K]ZQ;%D>&
-M1%P22D51+(GCH$,G[&KHJ7R@;:G3<[8%'N]L#/>9%7S`S.$?<WV9)LF**B=)
-M\WUGXV183F"8E;RF-Q=K<4U9^49>0_DJ><:(C8'8(*DH*!K:%/68J_R&3LQ@
-M0\7\F@*+DD@+,$+SP_T*DS*&/K"*&4/(4&]@*6X<<55UD40:I``16GT"4L<=
-M#1;@@,\6DP?/Q;.+:Q9`DFN+K,XV-PH2VIG`63I1DPZVQ'@PFBS?1!?)_`,X
-M%1AD`>.D@J8D.5)$)@ZE*O;AV0N-`1.0N$2:6RD799'*2\88GJ6&1MN[%3">
-M[?T(Z''2!`??,"6`0&/*JORD);CZ&A8'_'#;372\8C8F>-92,"PZ\JC9]L]R
-M2:BO?%7(K]'"4%_%VDC>#SZ;)A-W,<VGOCGM$C76^CL>_1GOXF2KK21/$-<>
-M;G0]!*[!>SS@+8R\"_Q'4MHE>('A>PW0HP5H.L@@)3Q#\FQIAN+HAE1P1T\G
-M85$OMN-9;%%H8:M?V+#9;Y`!#`#9^.KBU@W#:7,6N,OFC%@M%8S85`4C5_%S
-M=F+CA'?+F;+%_YD</S;GZ=/%S-%(T#'M:>#\-N.%8V/F[QB3'GP$<V;24%%(
-MO/*.!R%5F^<N^'!2F,YEM(?\BC2XR*,MY_+/BJ;^+O/'6UGG"0$96H6+<.PE
-M6\FQ.VILF,3M,XP<#]UE3S1Y&NY*`:OH!YA>D&EAZJNMRU$'NK4*GS36Q8<.
-M=_?,P`N->&L4OYB@U^@FU&%PC=J]H/:QD3#8P>,,ALW+J0Z/ZT5X@`BYKS;/
-MVO9`[N;_&V*7#24K%;X,+S%$RPOO(9PNYG#)-G9"]/PW1,]Q(ZIMQ`Q<&>1$
-M\1&PQO^B;RC`_WSW#F/Y@9"5J(]:(Z.SS:>S0A(*&QKKGM>\VU"Y9W@5@\-)
-M2"+E_\%<#9V(Z4!"Z<:Z7[4[PWFW>FF5-NJN;J`6UUG&&^F.*LHQZ"`G9!)4
-MSHF+Q'301K.LQ@DA;49539A"\JY3E\BW6<AO\]W*@:L6!*T71+T@7N6"4*^8
-ML&DGWJ'VH6FWVXYVQ^A>LK(6=QC8H2=5TV,U-*Y1.]EHG]4X<8VC:@;:H,.V
-M&BT>XL)61"^H(G/AR'Z.)?.&46_V6\N((M7`EN_5T%M05:^.Q]GL=0S?^:WX
-M>P"<+L.)"L>TI+.CG9C[?A0'>*'!]X=%.'7GH3B,_"58S(3O@(3CAH23=C1'
-M?<O/Z-4?"BXOJFK'AT>"1G--5B:;?)(BV>^AXQ&2$D2KZC>!M]Q4G8B<I6GM
-M:M:XEWP9S/>`B`V)E%UKYKA?ZET9IR$GZ55IH6\Z$C^-B9K<YEJ91SK1U#/W
-M_/P>S:\S/J;?!R7SVVY.0_"O!F&YX:78S%32C2%Q'UJZ3\D7'IV&F%\KGN2A
-MP8(G$[2@=OL[K<IZB03I$"W=;6^O2JH!?:03E<ZREG-A+X64UQV+)7U\[-^S
-MW\($3WLV7@G\4.5I=[0?+H.&Z3-H&QJ?,UI')]X<N(Q*.\!%5-J%R^AX7"]S
-M3'%W:@EO8T/)>D/6E*PV9+4VGW/<UL9O[(.MW!]!R@Q?=)QM;^/3:.8(QD8P
-M.%JQIZ3KW!.4,:^&#H\Y0.D+K`9[F)F$IY;*ZSCJET?NIPK!1:\0J6W;L4ZT
-MJSUJV-#X,<5Z(RX%C/BE@!&_%##BEUDK5&/BV">Z'TSL(W(E9>Y!3T6[CFY/
-M8:+[`?,!@V22Y^K4T7.-UY)XW3$()U6\W6<-SDFQ<[U;[-ZME]/13W0_RTG&
-M0-HSMDZOC=W5>.9[+EYRD'T9,<;86S9D@>#+F][B93B>3\;!I`U?T.__^>7J
-MSS]^9XQQ[H,+*P;ZQ&>GM_)^SP87'>S#ZID?RT(0=B9+OBD&+]FN#,%5L[$\
-M?[,D;^;8.X<[&6%/"&EKA)<CM#P'(P'%8AVRWJEN<_"X"/9D:\3VUV9S=ME^
-M5/3C.XU;Q;U+'@U)#T(]QAWUTL-`>;21V#A:H\JNYOQ-S2V4Y@?<QQ0G<K&9
-M5Y9U\%65V)=FV(^<MQDYWG]LXZP41K44FNQ0)JQ&,7^-N2<YFAG;I_YE;)_2
-MYNF0UNDB(#,2'32XXN4)JR1,$EM2PAIIMDAOUR`>;Y!G?U)M)0#S>I2S.1I=
-M9FV8K5&4H61_9B9Q$(/]%()F970#$\N1[<P#!O7J4;(Z.JI@H^B00K(Q`/3J
-M&<X-Q^`<*'!^2:/SR\'A>26^\_=;730@'(O>J`4%X8)M;EP\L'=G18PVO2G9
-M"MYTVVT`-K3?#XAQBO@3([GPAJGSP>"L>'@E=XF$`$:O70#/;834NX;LKM7&
-7X3+\#*8F?%C"'$;_0/\'$>IUA(V0````
+M'XL("-?H\4T``W-T<FEN9RYR97,`[5UM;]LX$O[.7T$85\"^L*Y$67Z)+P%V
+M>_NAP.:P0._#`=F@<&*U\5:V55EI;1_NO]^0%$5*HF0YMN/855#4,E^&PYF'
+MHYD1:7W\]S\__`MC;%_CWS_\BAO1(FK[D_O&$'V,:^@UAL)/D]DD:K:&B'WB
+MZVN\B,+)[$M[YOUH+Z)1E#1WKG%RW6FK:[>-@W#^@&]6?T#'J#GV/N,?CZ.H
+ME;3HMO%_DR^]-OR'&ZR%QLN`E[+"I,RV1<N`4^4450?;X95:G:IR13\QCUQ'
+M,;Y>J>H&V1$)_K/Q9O%G0R-`[<S(!$.3AJ)"'2.5($W%-5`)="H](Q4_365@
+MH.)K5)R<##F588J*DY4EHS+4J;A&*C0M&*=G($-UR3AF^=+TI#HF`5-]5AVS
+MA*,T&9.$(YT*\/N_Y$M?H;L#;/J3181]?(5M@NDPJ7*MZP3G/I!B=-&M?7>)
+MV$I#MU1<4:0!TUBOXP_91.\0X\E0"O@P$D,Y`"#&?Y,5VBW"/FBKA7(*KD*,
+M"E90OB([#)+CH)S,T;MW?&T+L1*\F*P]&,HTO!2TK?3A4JD//U&>ZVB*2#3A
+M38-HQ=NF%*`5I^1N$+I!XEKO(D&;9%O<C8NT6)R5!6CI8TBY=#2YP0I@$/;Q
+M14ITW1K#+X/AGJ:+OM#%9+;P0I`[P1RULG90HA)-R7((&,PIT]*&+CLK;@/]
+M(ET*>)/**MUNF`I:CAE`S]2V4Y6S6*U=2P&@"W<U_]:V[@`$;J+X+M5:P%TM
+MU@S#`&B`N$E=Y_D`88/R2_<Y6-%Z9V%#7#-P<N5;0$<;;AL4\0]W%S`5#YS@
+MBJ!\W09HB4^W.L1LZQD,2Y"X&IBZ#&[.'3<YT7?OH<D4XRB3TP7CY-]V6(/&
+MXT2Y3=W^<Y'&!T!`DG][G.P$O#)B&1SRIN1Q4@#'PNK*J"SCI3)(E0H(D_>N
+M@-V")XE?(0@$DM@2QQKKB/-^*%"734K"<Z`PWK,8QKL,PISKQN.\`6P\>IJ3
+MW[/W!^>NN)2]6>F<%U!5X.T9]5N/6;0X'N?DT=NT1,R-=E@H6[/_[/6D$,`!
+ML/_UM>M4#,L0Q(U`WCLO1S5W)";_<@MT:ZG(=:DY/CV'K>,^6\?Q4E7+]]E^
+MS[-9[8MO("9_<C\;33V,+W%<PO)<O.A2<A571*O`XQ0N0:"S+T_^*#R.(3@$
+M]^4F)1B%0#/R0BP3?T.,6$>9XL,RKX=SR3R<R>#A?-H.9W-UN#!!AXU9.4/[
+MH*!]4-#>+VCO%[0?%K0?%K2G11.@13.@12S1(IZB@@X\(X;0,/2BIW#&\L"H
+MVEVBUOO9Z_WP-_Y#F*N]N1"-&N+G!O$#Q%VO!^DE'F:-Y'-#\B&BAMK@G1U,
+M7C)9<T1+*,-%+0/:8QG0R>PK_,=RG.^B::"RG#V>_>R+U)$JW6/N<VMA\!E>
+MXE\^OO_P(2Z:SL>>DDTL%S:1N&0>>#,HF<WC[Z$W&O/O$;]<Q<4_PDGDZ<5'
+MCDR/,]/R*):-52WN,;9\24_Y..+;FU?-UF13+,?C9>E>F31+/#<.MP/<ZU-J
+M>,7WB./H1]X0M*<-?:N-F07!87*_Z&L/%T)YOP#*&#\\@B?U`(X4R&7R`(,[
+MU+(<43=[FMZ#AS7_C+^/P@6K$^7\[]Z?/WQEDH/R>3CV^(CC0&NA_B[YW!?L
+M<HE7>&T@0W4R[U/6_C7SF;+53<Y3BS279$76\#D.FO#U?=9JL#54M6W0>-T"
+M,%C;1N'<&@;S>4*3H^6*,QF^,EF4F#`^_JL6C30LVM.1OM/&D[$W\K%R5/O:
+M8Y&)-#SL/["K5U9JF5OIQ609%DVV+.!E!@AR-IJ6Z7:M!C=I-U^:(E>B,C%S
+MC;R4`'CZ2D3@ZL=*F[$MF]3IJ"TV_9Z2U4S*BC=)R4F4I)W$3*/$)324!TFY
+M06Z"MR:O-PG/V)$N"FOR-$LD&`M&4)(RZ>O2&[0Q>`S1/,3?07JWRPN;X-5=
+M(L"!MN?UNQ3@\N]?O!GX&Q<K?D%;%^)[.J!@I%9W::E6Z"D%7;$I=[[CH0S2
+M%W-K%A$S*:1P8)..*C>NQ$R))F,E%8XG]65KRAW0-@[F_@H'H-HEO5@Y%S.E
+M66T3;2`U"RV@77Z!Z.4IA9H[2!T6UP:96H/J&.=-K8U)5R4D:)8!DT;R8Y2H
+M@(M2IR@EJ6V[';C)XVSE*@ZZ+.$PX/NQ5"'/0O18H:846)LL-P+F#LJ_JW*V
+M*_W6986!++2MLOWH6[KFKKC49U?57>_%-$4GY;R_VOLL:(+S^$G<5/:;$*D%
+M699OT<029U3$=:%+1ZQ-B9E]D-PA@U/K>Z<$4<X`YU)&*5^'E#C_1+J4^T\L
+MU4JNEK?2UV*2Q(J_%J]'9.V>X\KCR)#V2D.I+)`D27SR@NFQ&F4J^V9;Z@R8
+M;8$?.QW!+64)'S!S^,<<6J8TLJ3*'](\VNDH'1D3&&8IK^G=U4I<4U:^EM=0
+MODR?J6%C(#9()HR)AS:%+>:JH*$3,YA+,;^F@)TDT@*,T.*(>XM)&6,76+",
+M(62H-["4-(ZY*ED/L;)`Z4M,MV=6ZK.C00#\ZNE\_.1[>'IURZ(]<FN1Y<7Z
+M3JE?.]HVS>9%LN&2&`]&D^7K^"*=%P!?`<.\89Q,V),F1\K(),'0EGUX5D%C
+MP`0:+I'F1LIE29OJDC$&6)FAT>9N)8SG>Y?#3`""X/!K`K-M)B2!T]-PUN<G
+MM>[B4P73$<'3EH)8V5$]S49_DG!77SGBY=<8].JKP'W:KG\R32;I8II/?9/9
+M)="K]7<Z^C/>C<E&.T@.$(H>;W0]:JW!>SK@+0V62_Q`4OEV_PHC[AJ@)PO0
+M;+!`*GA]Y,4R`^51"MG"U3S)'$.]KDYG7<51A*U^&<)FOW,%&@<0XYNK>R^*
+M)LUIZ"V:4V*U5-QA4Q5WW"2/L8F-4XXL9\H6_^<R\-B<1<\6,Y\B1<>T$X#S
+MVTS6B(V9:V/,4_`1S'E#0T4I\;)]`D*`P#-+-W#24G#.=;Q-^H8TN'CC7=7R
+MSXJG^3;WQUM9EREA&%I%\VCDIUO)L3MJ;&#X_@5&3H9VV;-%GB6[42`J^^F?
+M5V1&F/IJ2W+2\6NMPH.&L/C84>R>&7BE@6R-XE<3RQI=@CJZK5&[%]0^-\`%
+M.WB:,:YY.=51;[W>#K/>9`324YM3;;LOM[;_!6'*FI*EBE0&UQB"X+G_%$WF
+M,[ADNRDA*/X+@N*D$=5V/X:>C&?B4`A8XW_Q-Q3B?[Q]B['\0,A*U<>MD=&O
+MYM-9(@F%-4UTSVO>KJG<D[M,P.&D))%Q]6"NAD[$M#N_<F/=A=J=X:*[NC1`
+M:W4#-U!+ZBSC/7-'%178;I`3,@FJX/A!:CIHK1E1XX20-J.R,R8*M#O.4H+<
+M9H&\S7<#AY["/JVQ7V/_W+&OWCE@TTZR`^S7IMUN.]I]P+UF92WN!K`#0*JF
+MRVIH4J-VBM$>JW&2&D?5]+5!!VTU6C+$E:V(7E%%YLJ1_1Q+)O[BWNP'?1%%
+MJH$M7[2@MZ"J7IT`L]GO\W_C-]AO(7"ZB,8JGM(RQ(YV*.S;21Q'A0;?GN;1
+MQ)O%9_,^A_.I\`B0<,>0<+U.YN!J]1G]]$=<JXMJN\.P0T&CN2)+D_D]2Y'L
+M]PCM$$D)HF6IO1=&Z4Q$*JVHJQG>;OI%(-]"(O8$4G:M6=Y>I3<JG(><I*^D
+MQ:[94/H\)FIRAFMEGNA$,\_"BW-QM+C.^/A\'Y3,[T0Y#\'_-`@K#!K%?J**
+M'@M)^M#*?2J^%N<\Q/RSXDD>M2MYBD!+:C>_^:BJ0TB0#M'*W9[SEIT:NR<Z
+M4>D7:YD4]NX_>=VQ6"HGP,$C^VE&<*JGHZ6`"E5.=4?[<2UHF#W-M:;)J9Y5
+M?';,@<NXM`-<Q*4N7,8'S;JYPWV[4TLY%FM*5FNRHF2Y)LN5^73@IC9!8Q]L
+M%?YZ3V[XLH-A>QN?QC-',#:"P=&2/;Q<%9X[3'@U=-AP[##``I?A'F8AH:@E
+MXSJ.^AF.QXE":]F+*FH[=JH3=;7G`FN:/%-8K<6E@!&_%##BEP)&_#)O<6I,
+MG/I$]X.)?02DI,K]YE"TZZ#U'":Z'S`?,?8E16Y-'137>*V(UQUC:[*-9_NB
+M,3<I=Z0KA^1NO7).?J+[63DRW-&>DG6Z;>PM1]/`]_""X^GSD#'&WN4@"P1?
+M_N0>+Z+1;#P*QVWX@G[[SR\W?_S^&V.,<Q]>60FFQP$[*U7T@R^X[,@<5D_M
+M6'*!L!-0\M4C>,&V4`BNFHW%Y9L%>3/#_B7<M`A[QD=;0[P8HL4EV`,H%DN.
+M]<YTFX%S1;`O6R.VFS6?=<OWHZ(?W]?;*N]=\2!&=A#J,^ZHGQT&RN-MN\;1
+M&MOL(2[>0MQ"67[`4\QP(A>;>6591U]5J?UBABW!1?N!DRW`-LY+85A+H<F.
+M0,)J%//7F#O(0<C$/O6N$_N4-4_'M$Y7(9F2>%O_#2]/625ADMB2$M9(LT5Z
+MNP;Q>8,B^Y-I*P%8U*.:S='H,FO#;(VB#"7[,S.I8P_L]P0T*Z,;F$2.;!L=
+M,*A7#]/5\6D!&\7G!-*-`:`W+W!*-P%G7X'S<Q:=GX\.SQOQG;]%Z:H!D5?\
+MWB8HB.9L)^+\B;VA*6:TZ4_(1O!FVVX"L*']?D",,\0/C.32&Z;.!X.SXN$G
+IN4ND!##\V07PTD9(O>;&=JTVCA;1)S`UT=,"YC#\&_H_"9!"?4N.````
 `
 end