Index: coeffs/gnumpc.cc
===================================================================
--- coeffs/gnumpc.cc	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/gnumpc.cc	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -221,5 +221,5 @@
     return;
   }
-  if (exp&1==1)
+  if ( (exp & 1) == 1 )
   {
     ngcPower(x,exp-1,u, r);
@@ -374,5 +374,5 @@
 
 
-
+/// test, whether r is an instance of nInitCoeffs(n, parameter)
 static BOOLEAN ngcCoeffsEqual(const coeffs r, n_coeffType n, void*)
 {
@@ -380,5 +380,5 @@
   
   return (n == ID);
-};
+}
 
 void ngcInitChar(coeffs n, void*)
@@ -415,4 +415,6 @@
   n->cfDBTest  = ndDBTest; // not yet implemented: ngcDBTest
 #endif
+
+  n->nCoeffIsEqual = ngcCoeffsEqual;
 
 
Index: coeffs/gnumpc.h
===================================================================
--- coeffs/gnumpc.h	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/gnumpc.h	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -15,8 +15,4 @@
 /// Initialize r
 void ngcInitChar(coeffs r, void*);
-
-/// test, whether r is an instance of nInitCoeffs(n, parameter) */
-static BOOLEAN ngcCoeffsEqual(const coeffs r, n_coeffType n, void* parameter);
-
 
 
Index: coeffs/gnumpfl.cc
===================================================================
--- coeffs/gnumpfl.cc	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/gnumpfl.cc	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -381,4 +381,5 @@
 }
 
+/// test, whether r is an instance of nInitCoeffs(n, parameter)
 static BOOLEAN ngfCoeffsEqual(const coeffs r, n_coeffType n, void*)
 {
@@ -386,5 +387,5 @@
   
   return (n == ID);
-};
+}
 
 void ngfInitChar(coeffs n, void *)
@@ -417,4 +418,6 @@
   n->cfDBTest  = ndDBTest; // not yet implemented: ngfDBTest
 #endif
+
+  n->nCoeffIsEqual = ngfCoeffsEqual;
 }
 
Index: coeffs/gnumpfl.h
===================================================================
--- coeffs/gnumpfl.h	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/gnumpfl.h	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -15,8 +15,4 @@
 /// Initialize r
 void ngfInitChar(coeffs r, void *);
-
-/// test, whether r is an instance of nInitCoeffs(n, parameter) */
-static BOOLEAN ngfCoeffsEqual(const coeffs r, n_coeffType n, void*);
-
 
 const char *   ngfRead (const char *s, number *a, const coeffs r);
Index: coeffs/longrat.cc
===================================================================
--- coeffs/longrat.cc	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/longrat.cc	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -2517,4 +2517,6 @@
   r->cfDBTest=nlDBTest;
 #endif
+
+  r->nCoeffIsEqual = nlCoeffsEqual;
   
   // the variables: general stuff (required)
Index: coeffs/longrat.h
===================================================================
--- coeffs/longrat.h	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/longrat.h	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -59,5 +59,4 @@
 
 void     nlInitChar(coeffs r, void*);
-static BOOLEAN nlCoeffsEqual(const coeffs r, n_coeffType n, void * parameter);
 
 number   nlInit2 (int i, int j, const coeffs r);
Index: coeffs/shortfl.cc
===================================================================
--- coeffs/shortfl.cc	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/shortfl.cc	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -87,5 +87,5 @@
 }
 
-int nrSize(number n, const coeffs R)
+int nrSize(number n, const coeffs)
 {
   float f = nf(n).F();
@@ -263,23 +263,23 @@
 
 namespace {
-static const char* nrEatr(const char *s, float *r)
-{
-  int i;
-
-  if    (*s >= '0' && *s <= '9')
-  {
-    *r = 0.0;
-    do
-    {
-      *r *= 10.0;
-      i = *s++ - '0';
-      *r += (float)i;
-    }
-    while (*s >= '0' && *s <= '9');
-  }
-  else *r = 1.0;
-  return s;
-}
-};
+  static const char* nrEatr(const char *s, float *r)
+  {
+    int i;
+
+    if    (*s >= '0' && *s <= '9')
+    {
+      *r = 0.0;
+      do
+      {
+        *r *= 10.0;
+        i = *s++ - '0';
+        *r += (float)i;
+      }
+      while (*s >= '0' && *s <= '9');
+    }
+    else *r = 1.0;
+    return s;
+  }
+}
 
 const char * nrRead (const char *s, number *a, const coeffs r)
@@ -353,4 +353,5 @@
 * test valid numbers: not implemented yet
 */
+#pragma GCC diagnostic ignored "-Wunused-parameter"
 BOOLEAN  nrDBTest(number a, const char *f, const int l, const coeffs r)
 {
@@ -537,12 +538,11 @@
 
 
-/// test, whether r is an instance of nInitCoeffs(n, parameter) */
-static BOOLEAN nrCoeffsEqual(const coeffs r, n_coeffType n, void* parameter)
+/// test, whether r is an instance of nInitCoeffs(n, parameter)
+static BOOLEAN nrCoeffsEqual(const coeffs r, n_coeffType n, void*)
 {
   assume( getCoeffType(r) == ID );
 
   return (n == ID);
-};
-
+}
 
 
@@ -577,7 +577,6 @@
 #endif
   
-
-
-/// TODO: Any variables?
-  
-}
+  n->nCoeffIsEqual = nrCoeffsEqual;
+
+  // TODO: Any variables?
+}
Index: coeffs/shortfl.h
===================================================================
--- coeffs/shortfl.h	(revision 17e58bd0adfff2102c82ae041746b1ff6830733c)
+++ coeffs/shortfl.h	(revision 03901613ac5a5b40f44fd7758528af836672e4e2)
@@ -16,8 +16,4 @@
 /// Initialize r
 void nrInitChar(coeffs r, void*);
-
-/// test, whether r is an instance of nInitCoeffs(n, parameter) */
-static BOOLEAN nrCoeffsEqual(const coeffs r, n_coeffType n, void* parameter);
-
 
 // Private interface should be hidden!!!