Index: Tst/Short/factorizeQa_s.res.gz.uu
===================================================================
--- Tst/Short/factorizeQa_s.res.gz.uu	(revision faf58fa448fff6919168c75277259dc4202064b0)
+++ Tst/Short/factorizeQa_s.res.gz.uu	(revision 5641361d547d954c224e5c07effaefe14c255070)
@@ -1,40 +1,86 @@
 begin 644 factorizeQa_s.res.gz
-M'XL(",P%$TX``V9A8W1O<FEZ95%A7W,N<F5S`(U82V_;1A"^^U<0;0^2*(K<
-MV7<-^U#T$J`H4J2W(@YDQ7:5.'9@*:BH7]_9]RPE!X$`:3G?S.R\=ZEW?__^
-MYL^F:=AU\\>;WYJ?]KO]ZG%[^]/EQ;N(P'6#Q`_;I^U^-K^\<+_-]75SO][L
-MGU^VQ[N_UA]VJZ>[_U:[_7J?I?AUD]=BU?1]<__R_*5Y>'XYWCUF1*Z:E^W3
-M0_/N:C8L/\V7LV\SMEK!?'F(O\?P.U]^_%HL4M?-E^W3U^?'\>H3M*P`^KIQ
-MU.;M%>J9WXC%T?U`!PO_S!>H=AZ)6<BLFC8P>!BYHM2!ZLCLMF;'+T!XPL6&
-M58.[>@U0LW3^::J6,100Q4P(9N(7S#,/X-:"6`JO,7+*",FEF@>3TN8H.?O:
-M:92`VB>]0W64H(I2Q:YJ]A*"BDN?C1)447)/.</,E+)BF(E<A+.W6)K_L/>_
-M7F"*/N#BBH45O`^U$`V-BB&`/(`^.EVNC7;6?9J7T+8S?/J60N*?<H"ZR(5Q
-M]0K%*PIK?5VML'M%(]KNW6%+_TE^PU!B`,RWUGZ[^7RW;W[F?,@(Q-9ZV32N
-MN3;87(?E6#42\-Q(S56SP5;JQ:9C/5.%1<26NC\@RP'06L>$!OL52+5!*3:`
-MF!<92:;#[/[P>F:"$K.AON;J`)6W=N;]^_SE^0&UH0]E)VQX1"\OJ&'CB66+
-ML2@UM6WC#QBW&,^:9TL:^.#2D+(`7&6`I2R@!YB%]9DL<*!96-.!QGD*@1,_
-M=.OY8C;B=V$0E3O?=V8]SU4_AL>JPK).21Q3U#%C,UTGO[:^NK;HUWIYZZH,
-M/2OBAKJVK5RSU+5U>^LFT(:TNAA^T#64;6?;^6*3O?.4SI/.>BB85[W;?SS5
-M>T:VT#TY*8'HP$-P8.,<N*4.<.K`P_<<\!O>MM2#6:2<=T!D!T[TGHHF<MHD
-M*2%Y%ICGO,;<?MX^/C8OQ17,8T@WK>+E<;FK*EG8<C#7A2R'E.VKQF@^]%PO
-MUHO#C5R,-PRG/"YV-[)E6JB,&8>QC%$Q)(^()TB8('7``P-E\&C"A0.LA@AH
-M!PP9*!)('!&-0">DM+TP?I>LS.TB`@3"0UD=@:)45A@AX+U!,G<2$/<)9(%D
-MA61;41VS1:K*5#L,V7.=@@(>8H9@?F>3,2K&W/8R0UQ8Z(4M*9#17MYQ;7@/
-MP15%L\,[/1@6@C8!E#4BJ3/)3Z*.A:!9FE#>,<$4!'T3A)KG4VW/FH?;E"J@
-MYM5`"YJI'GA=<"+88(6W/"8[`RVW`JHBY45FD-ZE*=!*P2'MDXLWR'!C3-A'
-M5T"K#8:.%OQ0[Z-/Z)4[N1&F[N1:.'7'R^@S[M1`RR3S[I!&X$$9GJD!R&W`
-M)Q*Y"2+`M.PQ*[FHAEB*O(-!YRJU,=50A%0&=!813)3"AM@J<+*1A\39C9C+
-M',^0M**>2&A>B`TSIII'.@)4PH=-1$"Q:N*D1$/'``0=.28C121WJ0=:KK"!
-M8QOHU%;@(8MN3J9D`'!(1F53`(HR;X#-$+-RZ">#-2)")753Q#5;G'BF0JC5
-MWB%UQFHFR#RB5D\`OTV<N=X">=8"+Y6CTP%.Q=0A*0U>1C+=E]EN`[63JK"G
-MW&3V,N]59*?:4\8FVKT6'LG:6E>2I/(QO9ZJ2&DGFN?,I>NH!DR*IR6]TQJK
-M\R0D"6V9TI846B%+E?,"I:&\GCBA:;Y:SJ4A=9G(Q!S?1N*,.:JT%S6'DH%K
-M51U!/D<M`Y.M2?%"LC#,D*/'$[NXFTVI;(660,\A4U1J.D>0:!57Y>SQ-*R#
-M:J1,C$SE-S$RI:HRLA"3D6GB((498:KC:$`B5U;1LT-/&..009.$H">)OU%T
-MPBIQ<FT2K5+D``DD8:PB)X2_>G36@CFY6HF6<5"]KFEE^UP4]?:Y@<OVA80'
-MU$"/#F>3.QP'0XX-XXF%,T]%7JZ3[@)_U=PO[@L)R&V[.;W7=UH!`[P3]0QC
-M7=Z+QN,.WQTU[^VP[C"#O1$#OD3">.PT&B`DOE#"$7O;X+LD=T\=TQQO>QRP
-M"G?YQGX8Y5'L.-ZRI>BMQC>U41RY(R@3G@\<%;GS=L#G\+3#:<+]DSSN.J7\
-M<MSE_Q+&L)+N_2VN%:ZAPY?<,?Z'H9%`WT_Q(_PGOX1*\E^<%"O_;Y[[K^[;
-1;L;FE\TO%_\#E'X])004````
+M'XL(".QDKE```V9A8W1O<FEZ95%A7W,N<F5S`)5:6V\=MQ%^]Z]8I'TX.JO5
+MDL-[#>NAZ$N`HDB1OA5)("N6J\2Q`TF!M?KU^6;();GGK(,T`JQ=#B]S^>:;
+MX4;?_N<?7_]K&`9]/?SSZ[\/7ST]/EU]N'_[U>M7WQ8)70\8_.'^X_W3X>+U
+M*_X]7%\/=S>W3Y\>[E_>_?OFA\>KC^\^7ST^W3S55>9ZJ,_V:ICGX>[ATR_#
+M^T\/+^\^5(F[&A[N/[X?OGUS4)<_75P>?COHJRNZN'PNOU_R[XO+'W]M&OGK
+MX9?[C[]^^K"\^8E&W03A>N#1X9LWV.?B>WM\X5\TT5'>S1';7I3!NBA>#6.>
+M(&+,*JN>^SWJ]+2=CG\(XI-96ET-.%5VH.V42=Y.M]4:"VQ3D[*:^(<NZAS"
+MT;;3E+XTT?03:35I.P=!&:N76+_QU$O4Z^?$H*V7:..ES72_G=Y<L)D5=KU$
+M&R_Q6XVPC@U6&I&H(#Q\`VC^5W_WMU<(T0]X>*/S$WV7L5`4+1M3%IHL%.],
+M%1OC8?KIHKEV/.#MM]4E\E8=-)59\*ML:+^PX7:_:;OA](4=H;N8HR_E9[6;
+M5/,!:4FMI_O;G]\]#7\Q1E4)E=1ZN!TXN6Z17,^7RR:1R-1$&MX,MTBEV=Y.
+M>M:^3;$EI>Z>,>69H"U/@L+R1,[?8I569"_:&M>QP^'N^<N1R9O$V][6B@[R
+M]6A6[W^??OGT'KO!AG82$A[2UZ]ZQ98SS8Y+VS1N=5O^A'+'95>]U,)@%(=A
+MC0(97P5ZC0(L0!1N=J)@J(_"34]HQJPNX.7/T\W%\;#@WS;!;LSY8V-N+BKJ
+ME_RZ05C=TW6&^=ZPF.IX6.VZ%W3=PZZ;R[>,,EC6EL?>M/N-::DW[69\RPQT
+MVZ6Z57_2-*P=#_<7Q]MJG8Q,,K1KH=6R]>/3C^?[[JQMXS*\;D+%@/?9@%LV
+MX&UO@.D->/]'!LB!;\?>@D,9V3?`5@/.]CU?N@ZOAZR;='&VFSA;3\/#NU\_
+M/3R]^W%XNYP4;5MC_UF[#.O/.["VF]A_!O-^'FV3=MGCD#T9"AHSK5>1`BFK
+MDD]>*75\_CY`^?/QSTCV[_UQF1)I[ZQ542>3*"]QQP7Q..RL.I_.^UC,-[OS
+MQ[,QGF\PWXY[)Q,D;E_AW:TPW>],7MAJ8TCIX`,9FTSPHKY1WH80G38I6;)9
+M'1R80M#!!1<59"3'::6T5TX[4B:0C=545L]ZDZ"]T>1$A/DX)Z5H%;FHZW23
+M/3DY[!N<\TXI(\9B0?1>H^BX:!1K+_,I>W(ZUV?:U4<<"4N]=<E$9:SR(4\G
+MKY+#@+4Q>BO>RJZE$*V+(9)Q6)&CJHE\4G`@;\\>S+:.!ZTC]K36F:`<E=DA
+M&NV35MYH72<;=HQ-+J6$4[US-L\>M34N4#(^:J?C.IV*8WP,.-7JI&PJVHQ$
+M.D:X,K";K:J1-@(,YTP*B#.V5"LFO<?^-JC@M"JF6JY`*&!.P3%:IZ`1&_8+
+M>:1HA+4)VD-_41Z6FLA>Q.[14L0XYN)58UI`8#&=XJKY>(#SE.8=M598(K.C
+M5L$ZFVQ(/A:58:+&:4$[2$R*"`X,-/`?5`T``N*/?R^*=7R03=Y:33`^>R-H
+M2M;#B89:QK'K#.Q2B(/'DN+L"8CR2F,IF1"KYQ@A&E8Q)@"KDLK1..\Y/4S0
+M#"?1`AL;G0`0@\GP1U`Q,585_,(J1P?MH$QN8I!XACV0$(*(G8GC[1FI[$Z'
+M3-.*6XCQX`U0B*3Q*1*MAD%'3=!`"UA:97:Z(SA:"8Y`<`1?).@7`&F*.%Y8
+M(R(@.P+AN"#AVI,BO$"9B<DALH`H8[FP(@AW1UB8T4S[6C`+VB^L,VOR[2JR
+M,[KFB/_2HG%_D5#?WH)%O*2`.0="!"DXBP@)'#50%P)>D-4@BT#9#0Q=($"%
+MZ)$_D722Z1.231.BCC0'C3!\,XL*,S(2D=+)<_29#L71AJD,!`V=0&A,QFO9
+MD-[3$+(36F%%(N@FE`0@&P]>\$`W4<Z2[$C.5@9=A(_A:PI*,MMI3`6S*P.>
+M"11\S5<A`_(:_`LC%:>BA8JY((!C41\(``V6O//%BQPM'<@983[4"P45K60O
+M,LE)-ML(F.<JDB.%LPUV`0$@)=8\<TA2O`'K"1ELUA3F`TP(<",BP0<EG1,#
+M[C)PMD?T.)>LVE0>YSB[$!CP3J+"$<8QY2!07#>B)K6M/@1*!B2BCXG_*_44
+M?`=34!K!0M`NJFT)BC&"!U%$$`(EE8)S-B'C?0`20&C16=55(<#'!Z95$CO+
+M*0PY(6=M^2!JE<BBUP>G6=``2A)*A.=4P,Y020-VH#?0C_.E%$U@,+`1?HC`
+M9B`>XV7_B/D)X0`D$$3;JA$S6W`):$PA0AR$GE1BRU"J@T,A`.1]5X^2XKKF
+MF-4B:G9)3[!O8+8&3QGP,,9;00(2&=C@1^@#L6821(X0SD0=0QRYTCI::Q*)
+MM@I4SD2O"T9`MLY@-1<RQ'&-N50\[BB@-+H$'B\1A^<\N@8$!T626ET0D/P_
+M\2Y%BA.#>9^8HXM6(Z.<HH$/K70H)79BMD.J81471\?9SJ%(@!X*(_QA440=
+M:GNI5:B!R&L,(P]0=`)R4RH%)S`*,HH5:CZ.BJ5<:8_<-MQA<$5$.Z5]+MUX
+M!9"@*>I81)6^6"D$V,,BP`N=@TVY!QHQ"R8@VA;EUJK<[NVS(T*/;<$D("<7
+MN'@F01=@Y9CDP.2("[<+K4IUG^F<[;ZG#(<[?;RCLTL+ZH%#@6:`<X5`86=-
+MB8LM=!?WMCLGM^U<P/S"7WG<`BOA`0S8!?Z'\_!H%CM"2`MS21Y:_+1@*?`]
+M6^VP(GA^@`1S8I3!,2DJ@W;)",OCB$<9-WP>U[(L"+&,TY*I(6_>]EFX"U4F
+M#]LP1X/(2,$S2KL9]!$CM[`:M)7?^'!P`!HQ-W/W9\'%((3R(BI`C'YL!D\0
+MC#/(2'D6-:2IYI:R[#VB4042Z]ZB)]I$K`\>MP`<[F0'>8-RG(L@[YAFL#SJ
+M"_HA]">^O/'YXP'HUKK*@0[LW280%(S<"]<9[($J9A4!KK!*1^0&JD"=(!IB
+M:$:(<+FAP`^\K51$^"'")0`'/^0O,^A[9^1IO@K,F5/V^K7Y[$*4NS*0(6>^
+M1IY!K=/K5^[H`G,]9PR('I209L<CR!Q<0Z2N,./BU@,R1AH%3LFS*=+P.3VC
+MY0>'!/[=OIX\HPUA7(=E!;1?*$/<3,"CY6>3$3UI<;-OZ`[C@O4F@QIU;P6W
+M9_CI`GE+@C_LR#&V>.$[2ZR0EY)HU\F^0AX!H0)L8RO@&2@V%&BCUU\1+_5;
+ME\Q!*F?,>[GLF0KY:+5MJ"QK8H,\:+0B7I(1M\0&:C!KA^F<E*1X"1H5Y"L?
+MQ(\U,YGU5\2/(%:G*N(E1\'`2"*,`'$H5?*8,]5P@6M81P/KJ8$YWZ:"2@W.
+M7.]FOE^ZDJSH_ZVM8B'=/EF@.S"99@^&Q@'<&^HN6X17N)6K.H`<G6WIDGLX
+M-Z.A0-B,/.0TY7JWNL0ZW[GDR^YB=4!&LMN(EBKO)EJ@AP`/(>N2MCYQGO'U
+M!I[3GAMFZ;98B@P@*`Q7<>9RRRM<KD.^1["]N"EQJXE\`>$;9`+4X[1$C9>"
+MBAB!`0DLA?Z8PW0^I:0^W(`+,@B2VVA@$)6.T`IROX.[*9Q%O$H:-G069Q,R
+M4R"L(6<ERK>D)7*>60Q-ETIR0TWHUM@7,:#'0KBC$S6YTTT>C1':E`!^X4;>
+M<,7F?GG_.YOK/I$Y?S7\?/_AP_#0JF>X+E_"^H^[ER^7CYLO8:Y]"3OYONOJ
+M1]`W`[15LPG'FW)%T_;X@H='M)DZ@`U76629KK)^&89Q1:HB-$\BRK<4;2"P
+M(N#>(@L""U05M!5:/D"M`F[90<E13JF;\2DVB\B*J&[7B<JJNF$1D9EC:>\U
+ME7/RL"WWU[09Y<F)KRAU%)"HEH?5*20B^493O:**5^ALF98[;149"_JPJ87`
+M%7T-;CG1S)1-\7UTS(1RI;/33@2XB=IUN[C:V6VGL]-2'U"#*P(ZS;S?B:17
+M3T*==M73U*&@5V\K&'%A]3.9+>!LUB%9T;P$NPI&`\;8@-2T-4@K-NE4,'(#
+MOIY3P9O7<)G.YX2-`,T:7-<#7FW/"6?C&W-J(IR:4[%P;HZL"3OF;`6@'2WF
+M=(E@\F8*!50$-0W,R8J:!$6`<C,C*A54JD#1@/)#16DJH::VR%=!J$LLUX+5
+M&"JI0F<'B<CN'J3ETU`5X<JT922HEWVC<?/JPQ.*H%\A;K-%X/6&<=9`$W^U
+MM3WEQ"II2VJ6BF#D6_F:!F%-*Q(1JNU\PI)9`)(LFYT*J&TF"J0JTLFI^818
+MB\3Z=;M3"2=;8;RXD?1:BT%^1VMM.S[JM3X1R#&%<T4#MZN!K*K>F2ARCV`V
+MA"EK<$>8&[>G/#KQMY^:4"4V=7KC>U^F][NO$3O9778Q99B+-$+7(1_AE5'?
+M07L=DYD5NCR*>\_JS]3ESHA+:67"+J"X/834`:T-.U_C0BVA9)_"T'V\1F-P
+MHVRX7(<[=22-[(XZOJ57KTX_3'(OZ$J0Q`B]>:S:K/[",%J:V)4>&9S*:6D-
+MY6B#H[X.Q;9EZ'D$@XFOC[7VR!APL*&4$R57^)THN89JHV0;7)5<&0<C:$?C
+MIAPI#!K<_?K:$4XF%I*!2M;VE40ZBHF_3IVU37;TOBL@>0@=K.\JA+0>$[K0
+M>-9:6=SBR<]A.]:.KZ#8'E\3N!W?AB:^/76E@W7BXJAB5S:B#+:9E15-;2<]
+M_R_S-\/=\:X-Z>O-1YW3#SJX+./"BYYHQE4HM4\WR\LCFFU<&9.ZF1#!.7^4
+MI.5E"E#`.KY^O""WXZQQ)<';Q)_1I&<_OCRVJ_+B7NPC7TEP#TKAAB]!+X8'
+M?,SO?"5\X7JK\)[?'L$F1M[<R^/DO3PNC_5/;);\Y/C/&LJSQS--N&8LY4][
+K`@;Z/]O`CY6?^K<9GEIS[\V5_)$;_PG;;X\'??%Z^.NKWP&KI%B;&R<`````
 `
 end